> ## Documentation Index
> Fetch the complete documentation index at: https://v0.x-docs.novu.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Broadcast event to all

> Trigger a broadcast event to all existing subscribers, could be used to send announcements, etc.
      In the future could be used to trigger events to a subset of subscribers based on defined filters.

<Warning>
  Enter your API key in the `Authorization` field like the example shown below:

  E.g `ApiKey 18d2e625f05d80e`
</Warning>

<RequestExample>
  ```javascript Node.js theme={null}
  import { Novu } from '@novu/node';

  const novu = new Novu("<NOVU_API_KEY>");

  await novu.events.broadcast("<WORKFLOW_TRIGGER_IDENTIFIER>", {
    payload: {
      customKey: "customValue",
      customKey1: {
        nestedkey1: "nestedValue1"
      }
    },
    overrides: {
      email: {
        from: "support@novu.co"
      }
    },
    tenant: "tenantIdentifier"
  })
  ```

  ```php PHP theme={null}
  use Novu\SDK\Novu;

  $novu = new Novu(<NOVU_API_KEY>);

  $novu->broadcastEvent([
      'name' => '<WORKFLOW_TRIGGER_IDENTIFIER>',
      'payload' => ['customVariables' => 'Hello'],
      'transactionId' => '<REPLACE_WITH_TRANSACTION_ID>'
  ])->toArray();
  ```

  ```ruby Ruby theme={null}
  require 'novu'

  client = Novu::Client.new('<NOVU_API_KEY>')

  payload = {
      'name' => 'Trigger',
      'payload' => {
          'first-name' => 'Adam',
          'last-name' => 'Eve'
      },
      'transactionId' => 'sw900999as' #optional
  }
  client.broadcast_event(payload)
  ```

  ```bash cURL theme={null}
  curl -X POST https://api.novu.co/v1/events/trigger/broadcast \
    -H "Authorization: ApiKey <NOVU_API_KEY>" \
    -H "Content-Type: application/json" \
    -d '{
      "name": "<WORKFLOW_TRIGGER_IDENTIFIER>",
      "payload": {
        "customKey": "customValue",
        "customKey1": {
          "nestedkey1": "nestedValue1"
        }
      },
      "overrides": {
        "email": {
          "from": "support@novu.co"
        }
      },
      "tenant": "tenantIdentifier"
    }'
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	novu "github.com/novuhq/go-novu/lib"
  	"log"
  )

  func main() {
  	apiKey := "<NOVU_API_KEY>"
  	ctx := context.Background()

  	novuClient := novu.NewAPIClient(apiKey, &novu.Config{})

      name := interface{}{"<WORKFLOW_TRIGGER_IDENTIFIER>"}

  	payload := map[string]interface{}{
  		"name": "Hello World",
  		"organization": map[string]interface{}{
  			"logo": "https://happycorp.com/logo.png",
  		},
  	}

      data := novu.BroadcastEventToAll{Name: name, Payload: payload}

  	resp, err := novuClient.EventApi.BroadcastToAll(ctx, data)

  	if err != nil {
  		log.Fatal("novu error", err.Error())
  		return
  	}
  }
  ```

  ```python Python theme={null}
  from novu.api import EventApi

  url = "https://api.novu.co"
  api_key = "<NOVU_API_KEY>"

  novu = EventApi(url, api_key).broadcast(
      name="<WORKFLOW_TRIGGER_IDENTIFIER>",
      payload={"customVariable": "value"},  # Optional
  )
  ```

  ```java Java theme={null}
  import co.novu.common.base.Novu;
  import co.novu.api.common.SubscriberRequest;
  import co.novu.api.events.requests.TriggerEventRequest;
  import co.novu.api.events.responses.TriggerEventResponse;

  public class Main {
      public static void main(String[] args) {
          String apiKey = "<NOVU_API_KEY>";

          Novu novu = new Novu(apiKey);

          SubscriberRequest subscriberRequest = new SubscriberRequest();
          subscriberRequest.setEmail("<EMAIL_ADDRESS>");
          subscriberRequest.setFirstName("<FIRST_NAME>");
          subscriberRequest.setLastName("<LAST_NAME>");
          subscriberRequest.setPhone("<PHONE_NUMBER>");
          subscriberRequest.setAvatar("<AVATAR>");
          subscriberRequest.setSubscriberId("<SUBSCRIBER_ID>");

          TriggerEventRequest triggerEventRequest = new TriggerEventRequest();
          triggerEventRequest.setName("<NAME>"); 
          triggerEventRequest.setTo(subscriberRequest);
          triggerEventRequest.setPayload(Collections.singletonMap("<CUSTOM_VARIABLE_NAME>", "<CUSTOM_VARIABLE_VALUE>"));

          TriggerEventResponse response = novu.broadcastEvent(triggerEventRequest);
      }
  }
  ```

  ```csharp .NET theme={null}
  using Novu.DTO;
  using Novu.Models;
  using Novu;

  var novuConfiguration = new NovuClientConfiguration
  {
      /** 
      * Defaults to https://api.novu.co/v1 
      */
      Url = "https://novu-api.my-domain.com/v1", 
      ApiKey = "12345",
  };

  var novu = new NovuClient(novuConfiguration);

  var testRecord = new TestRecord
  {
      Message = "This is a test message"
  };

  var dto = new EventTriggerDataDto()
  {
      EventName = "<WORKFLOW_TRIGGER_IDENTIFIER>",
      To =
      {
          SubscriberId = "<UNIQUE_SUBSCRIBER_IDENTIFIER>"
      },
      Payload = testRecord
  };

  var trigger = await novu.Event.TriggerBroadcastAsync(dto);
  ```
</RequestExample>

<ResponseExample>
  ```json Response theme={null}
  {
      "data": {
          "acknowledged": true,
          "status": "processed",
          "transactionId": "string"
      }
  }
  ```
</ResponseExample>


## OpenAPI

````yaml post /v1/events/trigger/broadcast
openapi: 3.0.0
info:
  title: Novu API
  description: >-
    Novu REST API. Please see https://docs.novu.co/api-reference for more
    details.
  version: '1.0'
  contact:
    name: Novu Support
    url: https://discord.gg/novu
    email: support@novu.co
  termsOfService: https://novu.co/terms
  license:
    name: MIT
    url: https://opensource.org/license/mit
servers:
  - url: https://api.novu.co
  - url: https://eu.api.novu.co
security: []
tags:
  - name: Events
    description: >-
      Events represent a change in state of a subscriber. They are used to
      trigger workflows, and enable you to send notifications to subscribers
      based on their actions.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Subscribers
    description: >-
      A subscriber in Novu represents someone who should receive a message. A
      subscriber’s profile information contains important attributes about the
      subscriber that will be used in messages (name, email). The subscriber
      object can contain other key-value pairs that can be used to further
      personalize your messages.
    externalDocs:
      url: https://docs.novu.co/subscribers/subscribers
  - name: Topics
    description: >-
      Topics are a way to group subscribers together so that they can be
      notified of events at once. A topic is identified by a custom key. This
      can be helpful for things like sending out marketing emails or notifying
      users of new features. Topics can also be used to send notifications to
      the subscribers who have been grouped together based on their interests,
      location, activities and much more.
    externalDocs:
      url: https://docs.novu.co/subscribers/topics
  - name: Notification
    description: >-
      A notification conveys information from source to recipient, triggered by
      a workflow acting as a message blueprint. Notifications can be individual
      or bundled as digest for user-friendliness.
    externalDocs:
      url: https://docs.novu.co/getting-started/introduction
  - name: Integrations
    description: >-
      With the help of the Integration Store, you can easily integrate your
      favorite delivery provider. During the runtime of the API, the
      Integrations Store is responsible for storing the configurations of all
      the providers.
    externalDocs:
      url: https://docs.novu.co/channels-and-providers/integration-store
  - name: Layouts
    description: >-
      Novu allows the creation of layouts - a specific HTML design or structure
      to wrap content of email notifications. Layouts can be manipulated and
      assigned to new or existing workflows within the Novu platform, allowing
      users to create, manage, and assign these layouts to workflows, so they
      can be reused to structure the appearance of notifications sent through
      the platform.
    externalDocs:
      url: https://docs.novu.co/content-creation-design/layouts
  - name: Workflows
    description: >-
      All notifications are sent via a workflow. Each workflow acts as a
      container for the logic and blueprint that are associated with a type of
      notification in your system.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Notification Templates
    description: >-
      Deprecated. Use Workflows (/workflows) instead, which provide the same
      functionality under a new name.
  - name: Workflow groups
    description: Workflow groups are used to organize workflows into logical groups.
  - name: Changes
    description: >-
      Changes represent a change in state of an environment. They are analagous
      to a pending pull request in git, enabling you to test changes before they
      are applied to your environment and atomically apply them when you are
      ready.
    externalDocs:
      url: >-
        https://docs.novu.co/platform/environments#promoting-pending-changes-to-production
  - name: Environments
    description: >-
      Novu uses the concept of environments to ensure logical separation of your
      data and configuration. This means that subscribers, and preferences
      created in one environment are never accessible to another.
    externalDocs:
      url: https://docs.novu.co/platform/environments
  - name: Inbound Parse
    description: >-
      Inbound Webhook is a feature that allows processing of incoming emails for
      a domain or subdomain. The feature parses the contents of the email and
      POSTs the information to a specified URL in a multipart/form-data format.
    externalDocs:
      url: https://docs.novu.co/platform/inbound-parse-webhook
  - name: Feeds
    description: >-
      Novu provides a notification activity feed that monitors every outgoing
      message associated with its relevant metadata. This can be used to monitor
      activity and discover potential issues with a specific provider or a
      channel type.
    externalDocs:
      url: https://docs.novu.co/activity-feed
  - name: Tenants
    description: >-
      A tenant represents a group of users. As a developer, when your apps have
      organizations, they are referred to as tenants. Tenants in Novu provides
      the ability to tailor specific notification experiences to users of
      different groups or organizations.
    externalDocs:
      url: https://docs.novu.co/tenants
  - name: Messages
    description: >-
      A message in Novu represents a notification delivered to a recipient on a
      particular channel. Messages contain information about the request that
      triggered its delivery, a view of the data sent to the recipient, and a
      timeline of its lifecycle events. Learn more about messages.
    externalDocs:
      url: https://docs.novu.co/workflows/messages
  - name: Organizations
    description: >-
      An organization serves as a separate entity within your Novu account. Each
      organization you create has its own separate integration store, workflows,
      subscribers, and API keys. This separation of resources allows you to
      manage multi-tenant environments and separate domains within a single
      account.
    externalDocs:
      url: https://docs.novu.co/platform/organizations
  - name: Execution Details
    description: >-
      Execution details are used to track the execution of a workflow. They
      provided detailed information on the execution of a workflow, including
      the status of each step, the input and output of each step, and the
      overall status of the execution.
    externalDocs:
      url: https://docs.novu.co/activity-feed
externalDocs:
  description: Novu Documentation
  url: https://docs.novu.co
paths:
  /v1/events/trigger/broadcast:
    post:
      tags:
        - Events
      summary: Broadcast event to all
      description: >-
        Trigger a broadcast event to all existing subscribers, could be used to
        send announcements, etc.
              In the future could be used to trigger events to a subset of subscribers based on defined filters.
      operationId: EventsController_broadcastEventToAll
      parameters: []
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TriggerEventToAllRequestDto'
      responses:
        '200':
          description: Ok
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TriggerEventResponseDto'
        '201':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TriggerEventResponseDto'
        '409':
          description: >-
            The request could not be completed due to a conflict with the
            current state of the target resource.
          content:
            application/json:
              schema:
                type: string
                example: >-
                  Request with key 3909d656-d4fe-4e80-ba86-90d3861afcd7 is
                  currently being processed. Please retry after 1 second
        '429':
          description: 'The client has sent too many requests in a given amount of time. '
          content:
            application/json:
              schema:
                type: string
                example: API rate limit exceeded
        '503':
          description: >-
            The server is currently unable to handle the request due to a
            temporary overload or scheduled maintenance, which will likely be
            alleviated after some delay.
          content:
            application/json:
              schema:
                type: string
                example: Please wait some time, then try again.
      security:
        - api-key: []
      x-codeSamples:
        - lang: typescript
          label: EventsController_broadcastEventToAll
          source: |-
            import { Novu } from "@novu/api";

            const novu = new Novu({
              apiKey: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await novu.events.triggerBroadcast({
                name: "<value>",
                payload: {},
                overrides: {},
              });

              // Handle the result
              console.log(result)
            }

            run();
components:
  schemas:
    TriggerEventToAllRequestDto:
      type: object
      properties:
        name:
          type: string
          description: >-
            The trigger identifier associated for the template you wish to send.
            This identifier can be found on the template page.
        payload:
          type: object
          description: >-
            The payload object is used to pass additional custom information
            that could be used to render the template, or perform routing rules
            based on it. 
                  This data will also be available when fetching the notifications feed from the API to display certain parts of the UI.
          example:
            comment_id: string
            post:
              text: string
        overrides:
          type: object
          description: This could be used to override provider specific configurations
          example:
            fcm:
              data:
                key: value
        transactionId:
          type: string
          description: >-
            A unique identifier for this transaction, we will generated a UUID
            if not provided.
        actor:
          description: >-
            It is used to display the Avatar of the provided actor's subscriber
            id or actor object.
                If a new actor object is provided, we will create a new subscriber in our system
                
          oneOf:
            - type: string
              description: Unique identifier of a subscriber in your systems
            - $ref: '#/components/schemas/SubscriberPayloadDto'
        tenant:
          description: |-
            It is used to specify a tenant context during trigger event.
                If a new tenant object is provided, we will create a new tenant.
                
          oneOf:
            - type: string
              description: Unique identifier of a tenant in your system
            - $ref: '#/components/schemas/TenantPayloadDto'
      required:
        - name
        - payload
    TriggerEventResponseDto:
      type: object
      properties:
        acknowledged:
          type: boolean
          description: If trigger was acknowledged or not
        status:
          enum:
            - error
            - trigger_not_active
            - no_workflow_active_steps_defined
            - no_workflow_steps_defined
            - processed
            - subscriber_id_missing
            - no_tenant_found
          type: string
          description: Status for trigger
        error:
          description: In case of an error, this field will contain the error message
          type: array
          items:
            type: string
        transactionId:
          type: string
          description: Transaction id for trigger
      required:
        - acknowledged
        - status
    SubscriberPayloadDto:
      type: object
      properties:
        subscriberId:
          type: string
          description: >-
            The internal identifier you used to create this subscriber, usually
            correlates to the id the user in your systems
        email:
          type: string
        firstName:
          type: string
        lastName:
          type: string
        phone:
          type: string
        avatar:
          type: string
          description: An http url to the profile image of your subscriber
        locale:
          type: string
        data:
          type: object
        channels:
          type: array
          items:
            $ref: '#/components/schemas/SubscriberChannelDto'
      required:
        - subscriberId
    TenantPayloadDto:
      type: object
      properties:
        identifier:
          type: string
        name:
          type: string
        data:
          type: object
    SubscriberChannelDto:
      type: object
      properties:
        integrationIdentifier:
          type: string
        providerId:
          type: object
        credentials:
          $ref: '#/components/schemas/ChannelCredentialsDto'
      required:
        - providerId
        - credentials
    ChannelCredentialsDto:
      type: object
      properties:
        webhookUrl:
          type: string
        deviceTokens:
          type: array
          items:
            type: string
  securitySchemes:
    api-key:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        API key authentication. Allowed headers-- "Authorization: ApiKey
        <api_key>".

````